Summary: DHCPv6 - DHCP server and client for IPv6
Name:    dhcpv6
Version: 0.10
Release: 33%{?dist}
License: GPL 
Group:   System Environment/Daemons
URL:     http://dhcpv6.sourceforge.net/
Source0: ftp://ftp.sourceforge.net/pub/sourceforge/d/dh/dhcp/dhcp-%{version}.tgz
Source1: rfc3315.txt
Source3: libdhcp6client.pc
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Patch0:  dhcpv6-0.10-initscripts.patch
Patch1:  dhcpv6-0.10-change_resolv_conf.patch
Patch2:  dhcpv6-0.10-bug_136146.patch
Patch3:  dhcpv6-0.10-yywrap.patch
Patch4:  dhcpv6-0.10-relay_agent.patch
Patch5:  dhcpv6-0.10-server_relay_support.patch
Patch6:  dhcpv6-0.10-install_relay_agent.patch
Patch7:  dhcpv6-0.10-dhcp6r-init.patch
Patch8:  dhcpv6-0.10-server6_addr.patch
Patch9:  dhcpv6-0.10-bug_144585.patch
Patch10: dhcpv6-0.10-prefix_delegation_interface.patch
Patch11: dhcpv6-0.10-warnings.patch
Patch12: dhcpv6-0.10-use_glibc_ifaddrs.patch
Patch13: dhcpv6-0.10-165882.patch
Patch14: dhcpv6-0.10-install_no_chown.patch
Patch15: dhcpv6-0.10-no-strip.patch
Patch16: dhcpv6-0.10-prefix.patch
Patch17: dhcpv6-0.10-htonl.patch
Patch18: dhcpv6-0.10-libdhcp6client-Makefile.patch
Patch19: dhcpv6-0.10-libdhcp6client.patch
Patch20: dhcpv6-0.10-salen.patch
Patch21: dhcpv6-0.10-prefix_bz196429.patch
Patch22: dhcpv6-0.10-bz204713.patch
Patch23: dhcpv6-0.10-bz217309.patch
Patch24: dhcpv6-0.10-bz217308.patch
Prereq: /sbin/chkconfig, /sbin/service
BuildRequires: flex, bison, openssl-devel, autoconf, automake, libtool

%{?!NODEBUGINFO: %define NODEBUGINFO 0}
%if %{NODEBUGINFO}
%define debug_package %{nil}
%endif

%description
Implements the Dynamic Host Configuration Protocol (DHCP) for 
Internet Protocol version 6 (IPv6) networks in accordance with 
RFC 3315 : Dynamic Host Configuration Protocol for IPv6 (DHCPv6).
Consists of dhcp6s(8), the server DHCP daemon, and dhcp6r(8),
the DHCPv6 relay agent. 
Install this if you want to support dynamic configuration of
IPv6 addresses and parameters on your IPv6 network.
See man dhcp6s(8), dhcp6r(8), dhcp6s.conf(5),
and the documentation in /usr/share/doc/dhcpv6* .

%prep
%setup -q -n dhcp-%{version}
%patch0 -p1 -b .initscripts
%patch1 -p1 -b .change_resolv_conf
%patch2 -p1 -b .bug_136146
%patch3 -p1 -b .yywrap
%patch4 -p1 -b .relay_agent
%patch5 -b .server_relay_support
%patch6 -p1 -b .install_relay_agent
%patch7 -p1 -b .dhcp6r_init
%patch8 -p1 -b .server6_addr
%patch9 -p1 -b .bug_144585
%patch10 -p1 -b .prefix_delegation_interface
%patch11 -p1 -b .warnings
%patch12 -p1 -b .use_glibc_ifaddrs
rm -f ifaddrs.h
%patch13 -p1 -b .165882
%patch14 -p1 -b .install_no_chown
%patch15 -p1 -b .no-strip
%patch16 -p1 -b .prefix
%patch17 -p1 -b .htonl
%patch18 -p1 -b .libdhcp6client-Makefile
%patch20 -p1 -b .salen
%patch21 -p1 -b .prefix_bz196429
%patch22 -p1 -b .bz204713
%patch23 -p1 -b .bz217309
%patch24 -p1 -b .bz217308
%if %{NODEBUGINFO}
export CFLAGS=`echo "$RPM_OPT_FLAGS" | sed 's/-O2//g'`' -g3 -gdwarf-2'
%else
export LDFLAGS='-pie -Wl,-z,relro,-z,now,-z,nodlopen,-z,noexecstack'
export CFLAGS="$RPM_OPT_FLAGS -fPIE -g -Wall"
%endif
autoconf
%configure \
	--prefix=\
	--mandir=/usr/share/man
make libdhcp6client/.
%patch19 -p1 -b .libdhcp6client

%build
make
cp -fp %{SOURCE1} docs

%install
rm -rf %{buildroot}
pushd ${RPM_BUILD_DIR}/dhcp-%{version} 
for m in dhcp6c.8 dhcp6s.8 dhcp6r.8 dhcp6c.conf.5 dhcp6s.conf.5 ; do 
    /bin/mv $m $m.dos; 
    /usr/bin/tr -d '\r' < $m.dos > $m;
done;
popd
sed 's/@DHCPV6_VERSION@/'%{version}'/' < %SOURCE3 > libdhcp6client.pc
make install DESTDIR=%{buildroot} LIBDIR=%{_libdir} PKGCFGDIR=%{_libdir}/pkgconfig INSTALL_USER=`id -nu` INSTALL_GROUP=`id -gn`
mkdir -p %{buildroot}%{_localstatedir}/lib/dhcpv6
%if %{NODEBUGINFO}
/usr/lib/rpm/brp-compress
exit 0
%endif

%package -n dhcpv6_client
Summary:  DHCPv6 client
Requires: initscripts >= 7.73
Group: System Environment/Base

%description -n dhcpv6_client
Provides the client for the DHCPv6 protocol (RFC 3315) to support
dynamic configuration of IPv6 addresses and parameters.
See man dhcp6c(8), dhcp6c.conf(5), and the documentation in
/usr/share/dhcpv6_client* .

%package -n libdhcp6client
Summary: The DHCPv6 client in a library for invocation by other programs
Group:  Development/Libraries

%description -n libdhcp6client
Provides the client for the DHCPv6 protocol (RFC 3315) to support
dynamic configuration of IPv6 addresses and parameters, in a 
library for invocation by other programs.

%package -n libdhcp6client-devel
Summary: Header files for development with the DHCPv6 client library.
Group:   Development/Libraries

%description -n libdhcp6client-devel
Header files for development with the DHCPv6 client library.

%post
chkconfig --add dhcp6s

%preun
if [ $1 = 0 ]; then
  service dhcp6s stop > /dev/null 2>&1
  chkconfig --del dhcp6s
fi

%postun
if [ "$1" -ge "1" ]; then
  service dhcp6s condrestart >/dev/null 2>&1
fi
exit 0

%post -n libdhcp6client -p /sbin/ldconfig

%postun -n libdhcp6client -p /sbin/ldconfig

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%attr(754,root,root) %{_sbindir}/dhcp6s
%attr(754,root,root) %{_sbindir}/dhcp6r
%attr(755,root,root) %config /etc/rc.d/init.d/dhcp6s
%attr(755,root,root) %config /etc/rc.d/init.d/dhcp6r
%config(noreplace) /etc/sysconfig/dhcp6s
%config(noreplace) /etc/sysconfig/dhcp6r
%{_mandir}/man8/dhcp6s.8.gz
%{_mandir}/man5/dhcp6s.conf.5.gz
%{_mandir}/man8/dhcp6r.8.gz
%attr(750,root,root) %dir %{_localstatedir}/lib/dhcpv6

%doc ReadMe docs/* dhcp6s.conf server6_addr.conf

%files -n dhcpv6_client
%defattr(-,root,root,-)
%attr(750,root,root) /sbin/dhcp6c
%{_mandir}/man8/dhcp6c.8.gz
%{_mandir}/man5/dhcp6c.conf.5.gz
%doc ReadMe dhcp6c.conf
%attr(750,root,root) %dir %{_localstatedir}/lib/dhcpv6

%files -n libdhcp6client
%defattr(-,root,root,-)
%{_libdir}/libdhcp6client.so.*

%files -n libdhcp6client-devel
%defattr(0644,root,root,0755)
%{_includedir}/*
%{_libdir}/pkgconfig/libdhcp6client.pc
%defattr(-,root,root,-)
%{_libdir}/libdhcp6client.so
%{_libdir}/libdhcp6client.a

%changelog
* Wed Dec 13 2006 David Cantrell <dcantrell@redhat.com> - 0.10-33
- server6_addr.conf is not required for dhcp6s
- Resolves: rhbz#217309
- Man page for dhcp6s.conf should reference server-preference
- Resolves: rhbz#217308

* Fri Sep 29 2006 David Cantrell <dcantrell@redhat.com> - 0.10-32
- Line continuation slashes for init script description (#204713)

* Fri Aug 18 2006 Jesse Keating <jkeating@redhat.com> - 0.10-31
- rebuilt with latest binutils to pick up 64K -z commonpagesize on ppc*
  (#203001)

* Tue Jul 18 2006 Jason Vas Dias <jvdias@redhat.com> - 0.10-30
- fix bug 196429: 
  Allow clients from dhcpv6-0.10<=16 to get addresses. 
  >16, the server sent the prefix length; this is now
  conditional on the client sending the DHC6OPT_REQUEST_PREFIX,
  and can be disabled by the 'use-ra-prefix' dhcp6c.conf or 
  dhcp6s.conf setting. With the upstream version, the only
  way to set the clients' address prefixes was by router
  advertisement.

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 0.10-29.1
- rebuild

* Wed Jun 28 2006 Peter Jones <pjones@redhat.com> - 0.10-29
- getnameinfo needs the size of the incoming data, not NS_MAXHOST

* Thu Jun 22 2006 David Cantrell <dcantrell@redhat.com> - 0.10-28
- If link is down, exit rather than loop indefinitely (#195250)

* Tue Jun 20 2006 Peter Jones <pjones@redhat.com> - 0.10-27
- don't patch using autoconf, do it in the spec file so it can be
  patched on top of

* Thu Jun 08 2006 Jason Vas Dias<jvdias@redhat.com> 0.10-26
- libdhcp6client fix to retry bind() to linklocal address
  on EADDRNOTAVAIL for up to 5 seconds to give kernel time
  to create linklocal address.

* Fri May 26 2006 Jason Vas Dias<jvdias@redhat.com> 0.10-24.1
- misc libdhcp6client fixes

* Fri May 19 2006 Jason Vas Dias<jvdias@redhat.com> 0.10-24
- build libdhcp6client with -soname

* Wed May 17 2006 Jason Vas Dias<jvdias@redhat.com> 0.10-22
- Thanks, Karsten. Now building with libdhcp6client enabled.

* Wed May 17 2006 Karsten Hopp <karsten@redhat.de> 0.10-21
- change buildrequires from openssl top openssl-devel so that
  the configure checks actually work

* Sun May 14 2006 Jason Vas Dias <jvdias@redhat.com> - 0.10-20
- Produce the libdhcp6client library for invoking dhcp6c from
  within other programs.

* Wed May 10 2006 Jason Vas Dias <jvdias@redhat.com> - 0.10-18
- Make server send client the IPv6 address prefix in address lease;
  make client use it 
- prevent netlink.c generating error log message for NLMSG_DONE
- fix netlink.c IFLA_PROTINFO handling now that kernel defines it
- fix memory leak in client6_addr create_iaid
- disable 'install -s' for binaries

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 0.10-16.1
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jason Vas Dias <jvdias@redhat.com> - 0.10-16
- rebuild for new gcc, glibc, glibc-kernheaders

* Sun Dec 18 2005 Jason Vas Dias<jvdias@redhat.com> - 0.10-15.2
- rebuild for new gcc & flex

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Wed Nov  9 2005 Tomas Mraz <tmraz@redhat.com> - 0.10-15
- rebuilt with new openssl

* Mon Aug 15 2005 Jason Vas Dias <jvdias@redhat.com>
- fix bug 165882: allow client to configure an interface which
  does not have an IPv4 address ( use getifaddrs instead of
  ioctl(sockfd, SIOGIFCONF, ...)
- fix bug 165884 (possibly!): force use of glibc's getifaddrs,
  not internal getifaddrs implementation

* Fri Apr 01 2005 Florian La Roche <laroche@redhat.com>
- made perms for /var/lib/dhcpv6 the same

* Fri Mar 25 2005 Florian La Roche <laroche@redhat.com>
- add "exit 0" to postun script

* Thu Jan 13 2005 Jason Vas Dias <jvdias@redhat.com> - 0.10-11
- Fix misc. compiler warnings and ms-dos formatted man-pages

* Wed Jan 12 2005 Jason Vas Dias <jvdias@redhat.com> - 0.10-11
- Add 'prefix-delegation-interface' option to allow write
- of radvd interface configuration other than that for 
- the interface the lease was received on.

* Mon Jan 10 2005 Jason Vas Dias <jvdias@redhat.com> - 0.10-10
- Fix bug 144585: dhcp6c wasn't writing radvd.conf in prefix delegation mode

* Sun Jan 9  2005 Jason Vas Dias <jvdias@redhat.com> - 0.10-10
- Add Relay Agent support. Thanks to  Brian Bluesker<bbuesker@qualcomm.com>
- for the patch to add relay support to the server and for submitting the 
- patch originally contributed by Cristian Cadar of NEC Europe to 
- DHCPv6-developer  mailing list.

* Fri Jan 7  2005 Jason Vas Dias <jvdias@redhat.com> - 0.10-9
- fix bug 143728: SEGV core on resolv.conf + radvd.conf update -
- yywrap()'s must return 1

* Mon Oct 18 2004 Jason Vas Dias <jvdias@redhat.com> - 0.10-7
- fix bug 136146: clean up code - prevent compiler warnings

* Mon Sep 13 2004 Jason Vas Dias <jvdias@redhat.com> - 0.10-6
- fix bug 132468 for bug 125712: invoke change_resolv_conf

* Mon Sep 13 2004 Bill Nottingham <notting@redhat.com> - 0.10-5
- don't run by default
- add chkconfig prereqs, postun script, etc.

* Thu Sep  2 2004 Jason Vas Dias <jvdias@redhat.com> - 0.10-3/4
- fixed missing %defattr for dhcpv6_client - bug 131638

* Mon Aug 30 2004 Jason Vas Dias <jvdias@redhat.com> - 0.10-2
- Split into two packages: dhcpv6-*, containing server only,
- and dhcpv6_client-*, containing client only.

* Thu Aug 26 2004 Jason Vas Dias <jvdias@redhat.com> - 0.10-1 
- Initial build.

